﻿using HBLConsole.Interface;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using HBLConsole.Attributes;

namespace HBLConsole.MORKD
{
    /// <summary>
    /// 报警实体信息
    /// </summary>
    public class Alarm_MORKD : IAlarm
    {

        #region PLC-->上位机

        /**
         * Modbus地址数值，如何配置
         */

        /// <summary>
        /// 煮面机左侧低温报警
        /// PLC ---> M550.0
        /// ModbusTcp --> 1570
        /// </summary>
        [VariableMonitor("煮面机左侧低温报警", "550.0", "1570")]
        public bool MachineLeftLowTemperature { get; set; }

        /// <summary>
        /// 煮面机左侧低温报警
        /// PLC ---> M550.1
        /// ModbusTcp --> 1571
        /// </summary>
        [VariableMonitor("煮面机右侧低温报警", "550.1", "1571")]
        public bool MachineRightLowTemperature { get; set; }

        /// <summary>
        /// 供碗1缺碗
        /// PLC ---> M550.2
        /// ModbusTcp --> 1572
        /// </summary>
        [VariableMonitor("供碗1缺碗", "550.2", "1572")]
        public bool Supply1_LossBowl { get; set; }

        /// <summary>
        /// 供碗2缺碗
        /// PLC ---> M550.3
        /// ModbusTcp --> 1573
        /// </summary>
        [VariableMonitor("供碗2缺碗", "550.3", "1573")]
        public bool Supply2_LossBowl { get; set; }

        /// <summary>
        /// 供碗1出碗检测异常
        /// PLC ---> M550.4
        /// ModbusTcp --> 1574
        /// </summary>
        [VariableMonitor("供碗1出碗检测异常", "550.4", "1574")]
        public bool Supply1_ErrorOutBowl { get; set; }

        /// <summary>
        /// 供碗2出碗检测异常
        /// PLC ---> M550.5
        /// ModbusTcp --> 1575
        /// </summary>
        [VariableMonitor("供碗2出碗检测异常", "550.5", "1575")]
        public bool Supply2_ErrorOutBowl { get; set; }

        /// <summary>
        /// 推碗气缸故障
        /// PLC ---> M550.6
        /// ModbusTcp --> 1576
        /// </summary>
        [VariableMonitor("推碗气缸故障", "550.6", "1576")]
        public bool PushBowlCylinderError { get; set; }

        /// <summary>
        /// 煮面机通讯异常
        /// PLC ---> M550.7
        /// ModbusTcp --> 1577
        /// </summary>
        [VariableMonitor("煮面机通讯异常", "550.7", "1577")]
        public bool NoodleMacCommunicateError { get; set; }

        /// <summary>
        /// 煮面机通讯异常
        /// PLC ---> M551.0
        /// ModbusTcp --> 1580
        /// </summary>
        [VariableMonitor("配料机通讯异常", "551.0", "1580")]
        public bool DosingMacCommunicateError { get; set; }

        /// <summary>
        /// 机器人通讯异常
        /// PLC ---> M551.1
        /// ModbusTcp --> 1581
        /// </summary>
        [VariableMonitor("机器人通讯异常", "551.1", "1581")]
        public bool RobotMacCommunicateError { get; set; }

        /// <summary>
        /// 机器人初始化失败
        /// PLC ---> M551.3
        /// ModbusTcp --> 1583
        /// </summary>
        [VariableMonitor("机器人初始化失败", "551.3", "1583")]
        public bool RobotInitError { get; set; }

        /// <summary>
        /// 机器人急停
        /// PLC ---> M551.4
        /// ModbusTcp --> 1584
        /// </summary>
        [VariableMonitor("机器人急停", "551.4", "1584")]
        public bool RobotUrgentStop { get; set; }

        /// <summary>
        /// 机器人不在远程模式
        /// PLC ---> M551.5
        /// ModbusTcp --> 1585
        /// </summary>
        [VariableMonitor("机器人不在远程模式", "551.5", "1585")]
        public bool RobotNotInRemoteMode { get; set; }

        /// <summary>
        /// 机器人伺服未就绪
        /// PLC ---> M551.6
        /// ModbusTcp --> 1586
        /// </summary>
        [VariableMonitor("机器人伺服未就绪", "551.6", "1586")]
        public bool RobotNotInReady { get; set; }

        /// <summary>
        /// 机器人本体异常
        /// PLC ---> M551.7
        /// ModbusTcp --> 1587
        /// </summary>
        [VariableMonitor("机器人本体异常", "551.7", "1587")]
        public bool RobotSelfInException { get; set; }

        #endregion





    }
}
