﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Collections.ObjectModel;
using System.Collections.Concurrent;
using Microsoft.Toolkit.Mvvm.Input;
using Microsoft.Toolkit.Mvvm.Messaging;
using System.Threading;
using HBLConsole.ViewModel;
using HBLConsole.Model;
using HBLConsole.Service;
using BPA.Message.Enum;

namespace HBLConsole.DialogWindow.ViewModel
{
    public class ListDialogViewModel : ViewModelBase
    {
        public static bool IsAutoClose = false;
        public ListDialogViewModel()
        {
            Init();
        }



        private void Init()
        {
            CloseCommand = new RelayCommand(() =>
            {
                Json<KeepDataBase>.Data.orderLists.Clear();
                WeakReferenceMessenger.Default.Send("false", "Close");
            });

            CancelCommand = new RelayCommand(() =>
            {
                Json<KeepDataBase>.Data.orderLists.Clear();
                WeakReferenceMessenger.Default.Send("false", "Close");
            });

            ConfirmCommand = new RelayCommand(() =>
            {
                var res = orderStatusLists.Where(p => p.IsSelected == true).ToList();
                if (res != null)
                {
                    Json<KeepDataBase>.Data.orderLists.Clear();
                    foreach (var item in res)
                    {
                        item.OrderStatus = ORDER_STATUS.WAIT;
                        Json<KeepDataBase>.Data.orderLists.Add(item);
                        ActionManage.GetInstance.Send("DataParse", item.OrderPush);
                    }
                }
                WeakReferenceMessenger.Default.Send("true", "Close");
            });

            //if (Json<MorkOrderPushPar>.Data.morkOrderPushes.Count > 0)
            if (Json<KeepDataBase>.Data.orderLists.Count > 0)
            {
                ThreadManage.GetInstance.Start(new Action(() =>
                {
                    Thread.Sleep(10000);
                    if (!IsAutoClose) WeakReferenceMessenger.Default.Send("false", "Close");
                }), "延时退出");
            }
            AllSelected = true;
        }

        /// <summary>
        /// 全选标志
        /// </summary>
        public bool AllSelected
        {
            get { return _mAllSelected; }
            set
            {
                _mAllSelected = value;
                OnPropertyChanged();
                for (int i = 0; i < orderStatusLists.Count; i++)
                {
                    orderStatusLists.ElementAt(i).IsSelected = value;
                }
            }
        }
        private bool _mAllSelected = true;

        public RelayCommand CloseCommand { get; set; }

        public RelayCommand CancelCommand { get; set; }

        public RelayCommand ConfirmCommand { get; set; }

    }
}
