﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using BPA.Message.Enum;
using HBLConsole.Model;
using HBLConsole.Service;
using Microsoft.Toolkit.Mvvm.Input;

namespace HBLConsole.ViewModel
{
    public class ParSetViewModel : ViewModelBase
    {
        public ParSetViewModel()
        {
            WindowName = "参数设置";
            //
            if (SaveInfoCommand == null)
            {
                SaveInfoCommand = new RelayCommand(SaveInfoHandler);
            }
            LoadInfoHandler();
        }

        private const string ParSetJsonFilePath = "DistributePlc.json";

        private const string RootJsonPath = "AccessFile\\";

        //开机启动
        public bool IsSelected
        {
            get { return SystemHelper.GetInstance.IsAutoStart(); }
            set { SystemHelper.GetInstance.AutoStart(value); OnPropertyChanged(); }
        }
        //下拉框绑定设备类型
        public ObservableCollection<string> ClientDevices { get; set; }
            = new ObservableCollection<string>();
        //选中类型名称
        public string ClientDeviceType
        {
            get { return _mClientDeviceType; }
            set
            {
                _mClientDeviceType = value;
                OnPropertyChanged();
            }
        }
        private string _mClientDeviceType = string.Empty;


        /******煮面口********/
        private bool _hideNoodleNo1 = false;
        public bool HideNoodleNo1
        {
            get { return _hideNoodleNo1; }
            set { _hideNoodleNo1 = value; OnPropertyChanged(); }
        }
        private bool _hideNoodleNo2 = false;
        public bool HideNoodleNo2
        {
            get { return _hideNoodleNo2; }
            set { _hideNoodleNo2 = value; OnPropertyChanged(); }
        }
        private bool _hideNoodleNo3 = false;
        public bool HideNoodleNo3
        {
            get { return _hideNoodleNo3; }
            set { _hideNoodleNo3 = value; OnPropertyChanged(); }
        }
        private bool _hideNoodleNo4 = false;
        public bool HideNoodleNo4
        {
            get { return _hideNoodleNo4; }
            set { _hideNoodleNo4 = value; OnPropertyChanged(); }
        }
        private bool _hideNoodleNo5 = false;
        public bool HideNoodleNo5
        {
            get { return _hideNoodleNo5; }
            set { _hideNoodleNo5 = value; OnPropertyChanged(); }
        }
        private bool _hideNoodleNo6 = false;
        public bool HideNoodleNo6
        {
            get { return _hideNoodleNo6; }
            set { _hideNoodleNo6 = value; OnPropertyChanged(); }
        }

        /******冷库转盘当前位置********/
        private int _currentTurnPosition = 1;
        public int CurrentTurnPosition
        {
            get { return _currentTurnPosition; }
            set { _currentTurnPosition = value; OnPropertyChanged(); }
        }

        /******煮面口时间设定********/
        private int _noFirstMin = 0;
        private int _noFirstSec = 0;
        public int No1_Minute
        {
            get { return _noFirstMin; }
            set { _noFirstMin = value; OnPropertyChanged(); }
        }
        public int No1_Second
        {
            get { return _noFirstSec; }
            set { _noFirstSec = value; OnPropertyChanged(); }
        }
        private int _noSecondMin = 0;
        private int _noSecondSec = 0;
        public int No2_Minute
        {
            get { return _noSecondMin; }
            set { _noSecondMin = value; OnPropertyChanged(); }
        }
        public int No2_Second
        {
            get { return _noSecondSec; }
            set { _noSecondSec = value; OnPropertyChanged(); }
        }
        //
        private int _noThirdMin = 0;
        private int _noThirdSec = 0;
        public int No3_Minute
        {
            get { return _noThirdMin; }
            set { _noThirdMin = value; OnPropertyChanged(); }
        }
        public int No3_Second
        {
            get { return _noThirdSec; }
            set { _noThirdSec = value; OnPropertyChanged(); }
        }

        private int _noForthMin = 0;
        private int _noForthSec = 0;
        public int No4_Minute
        {
            get { return _noForthMin; }
            set { _noForthMin = value; OnPropertyChanged(); }
        }
        public int No4_Second
        {
            get { return _noForthSec; }
            set { _noForthSec = value; OnPropertyChanged(); }
        }

        private int _noFifthMin = 0;
        private int _noFifthSec = 0;
        public int No5_Minute
        {
            get { return _noFifthMin; }
            set { _noFifthMin = value; OnPropertyChanged(); }
        }
        public int No5_Second
        {
            get { return _noFifthSec; }
            set { _noFifthSec = value; OnPropertyChanged(); }
        }

        private int _noSixthMin = 0;
        private int _noSixthSec = 0;
        public int No6_Minute
        {
            get { return _noSixthMin; }
            set { _noSixthMin = value; OnPropertyChanged(); }
        }
        public int No6_Second
        {
            get { return _noSixthSec; }
            set { _noSixthSec = value; OnPropertyChanged(); }
        }


        //保存输入命令
        public RelayCommand SaveInfoCommand { get; set; }
        //保存界面输入功能
        private void SaveInfoHandler()
        {
            DistributePlcPar distributePlcPar = GetDistributeParUserInput();
            Json<DistributePlcPar>.Data = distributePlcPar;
            LocaPath.GetInstance.FilePath = RootJsonPath;
            Json<DistributePlcPar>.Save();
            Trace.WriteLine($"{nameof(DistributePlcPar)}，json文件已成功保存。");
        }
        //载入界面数据
        private void LoadInfoHandler()
        {
            LocaPath.GetInstance.FilePath = RootJsonPath;
            Json<DistributePlcPar>.Read();
            DistributePlcPar data = Json<DistributePlcPar>.Data;
            DistributePlcPar distributePlcPar = data;
            if (distributePlcPar != null)
            {
                this.HideNoodleNo1 = distributePlcPar.HideNoodleNo1;
                this.HideNoodleNo2 = distributePlcPar.HideNoodleNo2;
                this.HideNoodleNo3 = distributePlcPar.HideNoodleNo3;
                this.HideNoodleNo4 = distributePlcPar.HideNoodleNo4;
                this.HideNoodleNo5 = distributePlcPar.HideNoodleNo5;
                this.HideNoodleNo6 = distributePlcPar.HideNoodleNo6;

                this.CurrentTurnPosition = distributePlcPar.CurrentTurnPosition;

                this.No1_Minute = distributePlcPar.No1_Minute;
                this.No1_Second = distributePlcPar.No1_Second;
                this.No2_Minute = distributePlcPar.No2_Minute;
                this.No2_Second = distributePlcPar.No2_Second;
                this.No3_Minute = distributePlcPar.No3_Minute;
                this.No3_Second = distributePlcPar.No3_Second;
                this.No4_Minute = distributePlcPar.No4_Minute;
                this.No4_Second = distributePlcPar.No4_Second;
                this.No5_Minute = distributePlcPar.No5_Minute;
                this.No5_Second = distributePlcPar.No5_Second;
                this.No6_Minute = distributePlcPar.No6_Minute;
                this.No6_Second = distributePlcPar.No6_Second;
            }

            Trace.WriteLine($"已成功载入{nameof(DistributePlcPar)}json文件");
            return;
        }

        //获取界面用户输入
        private DistributePlcPar GetDistributeParUserInput()
        {
            DistributePlcPar distributePlcPar = new DistributePlcPar()
            {
                HideNoodleNo1 = this.HideNoodleNo1,
                HideNoodleNo2 = this.HideNoodleNo2,
                HideNoodleNo3 = this.HideNoodleNo3,
                HideNoodleNo4 = this.HideNoodleNo4,
                HideNoodleNo5 = this.HideNoodleNo5,
                HideNoodleNo6 = this.HideNoodleNo6,
                //
                CurrentTurnPosition = this.CurrentTurnPosition,
                //
                No1_Minute = this.No1_Minute,
                No1_Second = this.No1_Second,
                No2_Minute = this.No2_Minute,
                No2_Second = this.No2_Second,
                No3_Minute = this.No3_Minute,
                No3_Second = this.No3_Second,
                No4_Minute = this.No4_Minute,
                No4_Second = this.No4_Second,
                No5_Minute = this.No5_Minute,
                No5_Second = this.No5_Second,
                No6_Minute = this.No6_Minute,
                No6_Second = this.No6_Second,
            };
            return distributePlcPar;
        }

    }
}
